DocSlice (Solr 3.6.2 API)
Keywords: org.apache.solr.search.DocSlice class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.solr.search
Class DocSlice

    java.lang.Object
      org.apache.solr.search.DocSlice

All Implemented Interfaces:
  DocList, DocSet

    public class DocSlice

extends Object
implements DocList

`DocSlice` implements DocList as an array of docids and optional scores.

Since:
  solr 0.9
Version:
  $Id: DocSlice.java 790938 2009-07-03 15:09:21Z yonik $

Constructor Summary
`DocSlice(int offset, int len, int[] docs, float[] scores, int matches, float maxScore)` Primary constructor for a DocSlice instance.

Method Summary
`void` | `add(int doc)` Adds the specified document if it is not currently in the DocSet (optional operation).
`void` | `addUnique(int doc)` Adds a document the caller knows is not currently in the DocSet (optional operation).
`DocSet` | `andNot(DocSet other)` Returns the documents in this set that are not in the other set.
`int` | `andNotSize(DocSet other)` Returns the number of documents in this set that are not in the other set.
`boolean` | `equals(Object obj)`
`boolean` | `exists(int doc)` Returns true if a document is in the DocSet.
`OpenBitSet` | `getBits()` Inefficient base implementation.
`Filter` | `getTopFilter()` Returns a Filter for use in Lucene search methods, assuming this DocSet was generated from the top-level MultiReader that the Lucene search methods will be invoked with.
`boolean` | `hasScores()` True if scores were retained
`DocSet` | `intersection(DocSet other)` Returns the intersection of this set with another set.
`int` | `intersectionSize(DocSet other)` Returns the number of documents of the intersection of this set with another set.
`DocIterator` | `iterator()` Returns an iterator that may be used to iterate over the documents in this DocList
`int` | `matches()` Returns the total number of matches for the search (as opposed to just the number collected according to `offset()` and `size()`).
`float` | `maxScore()` The maximum score for the search...
`long` | `memSize()` Returns the approximate amount of memory taken by this DocSet.
`int` | `offset()` Returns the zero based offset of this list within the total ordered list of matches to the query.
`int` | `size()` Returns the number of ids in this list.
`DocList` | `subset(int offset, int len)` Get a subset of an existing DocList.
`DocSet` | `union(DocSet other)` Returns the union of this set with another set.
`int` | `unionSize(DocSet other)` Returns the number of documents of the union of this set with another set.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.solr.search.DocSet
`add, addUnique, andNot, andNotSize, getBits, getTopFilter, union, unionSize`

Constructor Detail

### DocSlice

    public DocSlice(int offset,
                    int len,
                    int[] docs,
                    float[] scores,
                    int matches,
                    float maxScore)

  Primary constructor for a DocSlice instance.

  Parameters:
    `offset` - starting offset for this range of docs
    `len` - length of results
    `docs` - array of docids starting at position 0
    `scores` - array of scores that corresponds to docs, may be null
    `matches` - total number of matches for the query

Method Detail

### subset

    public DocList subset(int offset,
                          int len)

  Description copied from interface: `DocList`
  Get a subset of an existing DocList. Returns null if not possible.

  Specified by:
    `subset` in interface `DocList`

### hasScores

    public boolean hasScores()

  Description copied from interface: `DocList`
  True if scores were retained

  Specified by:
    `hasScores` in interface `DocList`

### maxScore

    public float maxScore()

  Description copied from interface: `DocList`
  The maximum score for the search... only valid if scores were retained (if hasScores()==true)

  Specified by:
    `maxScore` in interface `DocList`

### offset

    public int offset()

  Description copied from interface: `DocList`
  Returns the zero based offset of this list within the total ordered list of matches to the query.

  Specified by:
    `offset` in interface `DocList`

### size

    public int size()

  Description copied from interface: `DocList`
  Returns the number of ids in this list.

  Specified by:
    `size` in interface `DocList`
  Specified by:
    `size` in interface `DocSet`

### matches

    public int matches()

  Description copied from interface: `DocList`
  Returns the total number of matches for the search (as opposed to just the number collected according to `offset()` and `size()`). Hence it's always true that matches() >= size()

  Specified by:
    `matches` in interface `DocList`
  Returns:
    number of matches for the search(query & any filters)

### memSize

    public long memSize()

  Description copied from interface: `DocSet`
  Returns the approximate amount of memory taken by this DocSet. This is only an approximation and doesn't take into account java object overhead.

  Specified by:
    `memSize` in interface `DocSet`
  Returns:
    the approximate memory consumption in bytes

### exists

    public boolean exists(int doc)

  Description copied from interface: `DocSet`
  Returns true if a document is in the DocSet.

  Specified by:
    `exists` in interface `DocSet`

### iterator

    public DocIterator iterator()

  Description copied from interface: `DocList`
  Returns an iterator that may be used to iterate over the documents in this DocList

  The order of the documents returned by this iterator is based on the Sort order of the search that produced it. The Scoring information is meaningful only if `hasScores()` returns true.

  Specified by:
    `iterator` in interface `DocList`
  Specified by:
    `iterator` in interface `DocSet`
  See Also:
    `DocList.hasScores()`

### intersection

    public DocSet intersection(DocSet other)

  Description copied from interface: `DocSet`
  Returns the intersection of this set with another set. Neither set is modified - a new DocSet is created and returned.

  Specified by:
    `intersection` in interface `DocSet`
  Returns:
    a DocSet representing the intersection

### intersectionSize

    public int intersectionSize(DocSet other)

  Description copied from interface: `DocSet`
  Returns the number of documents of the intersection of this set with another set. May be more efficient than actually creating the intersection and then getting it's size.

  Specified by:
    `intersectionSize` in interface `DocSet`

### equals

    public boolean equals(Object obj)

  Overrides:
    `equals` in class `Object`

### add

    public void add(int doc)

  Description copied from interface: `DocSet`
  Adds the specified document if it is not currently in the DocSet (optional operation).

  Specified by:
    `add` in interface `DocSet`
  Throws:
    `SolrException` - Base implementation does not allow modifications
  See Also:
    `DocSet.addUnique(int)`

### addUnique

    public void addUnique(int doc)

  Description copied from interface: `DocSet`
  Adds a document the caller knows is not currently in the DocSet (optional operation).

  This method may be faster then `add(doc)` in some implementaions provided the caller is certain of the precondition.

  Specified by:
    `addUnique` in interface `DocSet`
  Throws:
    `SolrException` - Base implementation does not allow modifications
  See Also:
    `DocSet.add(int)`

### getBits

    public OpenBitSet getBits()

  Inefficient base implementation.

  Specified by:
    `getBits` in interface `DocSet`
  Returns:
    An OpenBitSet with the bit number of every docid set in the set.
  See Also:
    `BitDocSet.getBits()`

### union

    public DocSet union(DocSet other)

  Description copied from interface: `DocSet`
  Returns the union of this set with another set. Neither set is modified - a new DocSet is created and returned.

  Specified by:
    `union` in interface `DocSet`
  Returns:
    a DocSet representing the union

### unionSize

    public int unionSize(DocSet other)

  Description copied from interface: `DocSet`
  Returns the number of documents of the union of this set with another set. May be more efficient than actually creating the union and then getting it's size.

  Specified by:
    `unionSize` in interface `DocSet`

### andNot

    public DocSet andNot(DocSet other)

  Description copied from interface: `DocSet`
  Returns the documents in this set that are not in the other set. Neither set is modified - a new DocSet is created and returned.

  Specified by:
    `andNot` in interface `DocSet`
  Returns:
    a DocSet representing this AND NOT other

### andNotSize

    public int andNotSize(DocSet other)

  Description copied from interface: `DocSet`
  Returns the number of documents in this set that are not in the other set.

  Specified by:
    `andNotSize` in interface `DocSet`

### getTopFilter

    public Filter getTopFilter()

  Description copied from interface: `DocSet`
  Returns a Filter for use in Lucene search methods, assuming this DocSet was generated from the top-level MultiReader that the Lucene search methods will be invoked with.

  Specified by:
    `getTopFilter` in interface `DocSet`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD